/*
 *  Copyright 2005-2006 The Apache Software Foundation or its licensors, as applicable.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/** 
 * @author Salikh Zakirov
 * @version $Revision: 1.5.24.4 $
 */  
package gc;

/**
 * @keyword gc
 */
public class Finalizer {

    static volatile boolean passed = false;

    public static void main (String[] args) {
        new Finalizer();
        int n = 17;
        while (!passed && --n >= 0) {
            System.gc();
            System.runFinalization();
            try { Thread.sleep(100); } catch (InterruptedException e) {}
        }
        if (passed) {
            System.out.println("PASSED");
        } else {
            System.out.println("FAILED");
        }
    }

    public void finalize () {
        System.out.println("finalizer is being run");
        passed = true;
    }
}
